package info.bukova.isspst.data;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Table(name = "TRIP_BILL_ITEMS")
public class TripBillItem extends BaseData {

	@Column(name = "DATE")
	private Date date;
	@Column(name = "TARGET")
	private String to;
	@Column(name = "BACK")
	private String back;
	@Column(name = "DEPARTURE")
	private Date departure;
	@Column(name = "ARRIVAL")
	private Date arrival;
	@Embedded
	private Vehicle vehicle;
	@Column(name = "BEGIN_WORK")
	private Date beginWork;
	@Column(name = "END_WORK")
	private Date endWork;
	@Column(name = "FREE_MEALS_COUNT")
	private int freeMealsCount;
	@Column(name = "DISTANCE", precision = 15, scale = 4)
	private BigDecimal distance;
	@Column(name = "FUEL_CONSUMPTION", precision = 15, scale = 4)
	private BigDecimal fuelConsumption;
	@Column(name = "CAREFARE", precision = 15, scale = 4)
	private BigDecimal carefare;
	@Column(name = "HOUSING", precision = 15, scale = 4)
	private BigDecimal housing;
	@Column(name = "MEALS", precision = 15, scale = 4)
	private BigDecimal meals;
	@Column(name = "OTHER_EXPENSES", precision = 15, scale = 4)
	private BigDecimal otherExpenses;
	@Column(name = "TOTAL", precision = 15, scale = 4)
	private BigDecimal total;
	@Column(name = "ADJUSTED_TOTAL", precision = 15, scale = 4)
	private BigDecimal adjustedTotal;

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public String getTo() {
		return to;
	}

	public void setTo(String to) {
		this.to = to;
	}

	public String getBack() {
		return back;
	}

	public void setBack(String back) {
		this.back = back;
	}

	public Date getDeparture() {
		return departure;
	}

	public void setDeparture(Date departure) {
		this.departure = departure;
	}

	public Date getArrival() {
		return arrival;
	}

	public void setArrival(Date arrival) {
		this.arrival = arrival;
	}

	public Vehicle getVehicle() {
		return vehicle;
	}

	public void setVehicle(Vehicle vehicle) {
		this.vehicle = vehicle;
	}

	public Date getBeginWork() {
		return beginWork;
	}

	public void setBeginWork(Date beginWork) {
		this.beginWork = beginWork;
	}

	public Date getEndWork() {
		return endWork;
	}

	public void setEndWork(Date endWork) {
		this.endWork = endWork;
	}

	public int getFreeMealsCount() {
		return freeMealsCount;
	}

	public void setFreeMealsCount(int freeMealsCount) {
		this.freeMealsCount = freeMealsCount;
	}

	public BigDecimal getDistance() {
		return distance;
	}

	public void setDistance(BigDecimal distance) {
		this.distance = distance;
	}

	public BigDecimal getFuelConsumption() {
		return fuelConsumption;
	}

	public void setFuelConsumption(BigDecimal fuelConsumption) {
		this.fuelConsumption = fuelConsumption;
	}

	public BigDecimal getCarefare() {
		return carefare;
	}

	public void setCarefare(BigDecimal carefare) {
		this.carefare = carefare;
	}

	public BigDecimal getHousing() {
		return housing;
	}

	public void setHousing(BigDecimal housing) {
		this.housing = housing;
	}

	public BigDecimal getMeals() {
		return meals;
	}

	public void setMeals(BigDecimal meals) {
		this.meals = meals;
	}

	public BigDecimal getOtherExpenses() {
		return otherExpenses;
	}

	public void setOtherExpenses(BigDecimal otherExpenses) {
		this.otherExpenses = otherExpenses;
	}

	public BigDecimal getTotal() {
		return total;
	}

	public void setTotal(BigDecimal total) {
		this.total = total;
	}

	public BigDecimal getAdjustedTotal() {
		return adjustedTotal;
	}

	public void setAdjustedTotal(BigDecimal adjustedTotal) {
		this.adjustedTotal = adjustedTotal;
	}

}
